function [signals,beta]=ampm(M)
%function [signals,beta]=ampm(M)
%pe=erfc((beta*ebn0)^.5);
switch M
    case 16
        elements=[4,12];
    case 32
        elements=[4,12,16];
    case 64
        elements=[4,12,20,28];
    otherwise
        disp('M must be 16, 32 or 64');
        return
end

signals=psk(elements(1));
r(1)=norm(signals(1,:));
for i=2:length(elements)
    r(i)=max(1/(2^.5*sin(pi/elements(i))),r(i-1)+r(1)*2^.5);
    signals=[signals;r(i)*psk(elements(i))];
end
sigsize=size(signals,1);
avenergy=sum(sum(signals.^2))/sigsize;
beta=norm(signals(1,:)-signals(2,:))^2*log2(sigsize)/avenergy/4;
signals=signals/(avenergy)^0.5;
