modulation=input('modulation (0=PSK, 1=QAM, 2=8ampm, 3=16,32,64AMPM): ');
switch modulation
    case 0
        bit=input('number of bits per symbol: '); 
        M=2^bit;
        symbols=psk(M); %simboli M-PSK
    case 1
        bit=input('number of bits per symbol (must be even): ');
        if rem(bit,2)==0
            m=(2^(bit/2));
            M=m^2;
            symbols=qam(m); %simboli M-QAM
        else
            disp('error ');
            return;
        end
    case 2
        el=input('energy levels (2,3): ');
        switch el
            case 2
                symbols=ampm8;
            case 3
                qam8;
                symbols=signals5n;
            otherwise
                disp('error');
                return;
        end
    case 3
        bit=input('number of bits per symbol 4,5,6: '); 
        if bit < 4 || bit > 6
            disp('error');
            return;
        else
            M=2^bit;
            [symbols,beta]=ampm(M);
        end
    otherwise
        disp('error');
        return;
end

N=input('simulation length (in symbols): '); %lunghezza simulazione (in simboli)
   %traccia il diagramma di scattering
ebn0_s=input('ebn0 dB (for scattering diagram): '); %dB
scattering(symbols,ebn0_s,N);
   %determina la probabilita' d'errore, confrontandola con la teorica
ebn0_min=input('ebn0 dB min (for BER evaluation): '); %dB
ebn0_max=input('ebn0 dB max (for BER evaluation): '); %dB
ebn0_step=input('ebn0 dB step (for BER evaluation): '); %dB
ebn0=ebn0_min:ebn0_step:ebn0_max;
ser_sim=ser(symbols,ebn0,N);
if (modulation==0)
    ser_the=erfc((log2(M)*10.^(ebn0/10)).^.5*sin(pi/M));
else
    if modulation==1
        ser_the=2*(1-1/m)*erfc((3*log2(M)*10.^(ebn0/10)/2/(M-1)).^.5);
    else
        if modulation==2
            if el==2
                ser_the=(3/2)*erfc((1/(1+1/3^.5)*10.^(ebn0/10)).^.5);
            else
                ser_the=(11/8)*erfc((2/3*10.^(ebn0/10)).^.5);
            end
        else
            ser_the=erfc((beta*10.^(ebn0/10)).^.5);
        end
    end
end
figure;
semilogy(ebn0,ser_the,'k');
hold on
semilogy(ebn0,ser_sim,'k*');
xlabel('E_b/N_0 [dB]');
ylabel('S.E.R.');
hold off
