function [p]=ser(signals,snr_in_dB,N)
% [p]=ser(signals,snr_in_dB,N)
%		SER  evaluate the symbol error rate for a given
%   		value of snr_in_dB (Eb/N0), signal to noise ratio in dB.
%      signals: coonstellation, one symbol each row;
%      N = number of simulated symbols
 
 sigsize=size(signals,1);
 basedim=size(signals,2);
 avenergy=sum(sum(signals.^2))/sigsize;
 snrsize=length(snr_in_dB);
 for is=1:snrsize
  	SNR=10^(snr_in_dB(is)/10);	   								% signal to noise ratio
  	sgma=(avenergy)^0.5/sqrt(2*SNR*log2(sigsize));   	   % sigma, standard deviation of noise

% data generation
	dsource=floor(sigsize*rand(1,N))+1;
% the detection, and probability of error calculation follows
% The matched filter outputs
	r=(signals(dsource,:)+sgma*randn(N,basedim));
   % decide
   if basedim==1
      for i=1:sigsize, sqdist(i,:)=(((ones(N,1)*signals(i,:))-r).^2)';end            %distances
   else
      for i=1:sigsize, sqdist(i,:)=sum((((ones(N,1)*signals(i,:))-r).^2)');end       %distances
   end  
   [a, decis]=min(sqdist); % minimum distances
% count errors
  	numoferr=sum(decis~=dsource);
   p(is)=numoferr/N;	  	      								% symbol probability of error estimate
end
